/* program pro ovladani pohonu zavory s Arduino NANO mozno pouzit i Arduino Uno
na ovladani na soukromem parkovisti
www.mojeelektronika.mzf.cz
vagnervlastimil@seznam.cz
*/
int SIG_LED1 = 2;                //signalizace aktivni snimac pripojeni na PIN2 cervena LED
int SIG_LED2 = 4;                //signalizace aktivni snimac a sepnuti rele pripojeni na PIN4 zelena LED 
int button = 8;                  //pripojeni vystupu prijimace na PINU8 
const byte IR_LED = 11;          //napajeni IR_led diody PIN11
boolean SIG_LED1State = false;   //pocatecni stav LED1  
boolean SIG_LED2State = false;   //pocatecni stav LED2  
long buttonTimer = 0;            //pocatecni hodnota casu
long longPressTime = 2000;       //hodnota mezi rozsvicenim LRD1 a LED2 spolecne se sepnutim rele
boolean buttonActive = false;    //pocatecni stav   
boolean longPressActive = false; //pocatecni stav   

void setup(){
pinMode(SIG_LED1,OUTPUT);        //nastaveni PINU LED1 na vystup
pinMode(SIG_LED2,OUTPUT);        //nastaveni PINU LED2 na vystup
pinMode(button,INPUT);           //nastaveni PINU prijimace na vstup      
pinMode (IR_LED,OUTPUT);         //nastaveni PINU napajeni IR_LED na vystup
TCCR2A = _BV (COM2A0) | _BV(WGM21); //nastaveni registru casovace
TCCR2B = _BV (CS20);                //nastaveni registru casovace
OCR2A =  219;}                   // 209 = ~38kHz, 219 = ~36kHz volba frekvence prijimace zde zvoleno 36Khz

void loop(){
if (digitalRead(button) == HIGH){  //nacteni stavu vystupu prijimace
digitalWrite(SIG_LED2, HIGH);      //rozsviceni LED2
if (buttonActive == false){        //do promenne ulozime hodnotu false "neni pravda
buttonActive = true;               //do promenne ulozime hodnotu true "je pravda"
buttonTimer = millis();}           //prirazeni hodnoty milis do buttonTima
if ((millis() - buttonTimer > longPressTime) && (longPressActive == false)){   //vypocet casu mezi LED1 a LDE2
longPressActive = true;            //nastaveni promenne Longpressaktive na true "je pravda"
digitalWrite(SIG_LED1,HIGH);}      //sepnuti LED1
}else{                             //pokud neni BUTTON v LOG jednicce pokracuje na dalsim radku
digitalWrite(SIG_LED2,LOW);        //vypnuti LED2
delay(2000);                       //casova prodleva pred vypnutim napajeni pro rele a signalizaci LED1
digitalWrite(SIG_LED1,LOW);        //vypnuti napajeni rele a signalizacni LED1 
if (buttonActive == true){         //pokud je promenna rovna true "pravda"
if (longPressActive == true){      //pokud je promenna rovna true "pravda" 
longPressActive = false;           //pokud je promenna rovna false "neravda" program se opakuje
}else{                             //pokud vsechny vyse uvedene promenne nejsou pravda pokracuje se na daleim radku
SIG_LED2State = !SIG_LED2State;    //zmena stavu LED2
digitalWrite(SIG_LED2, SIG_LED2State);}    //sepnuti/nesepnuti LED2 dle promenne LED2State
buttonActive = false;              //nastaveni promenne na false " neni pravda
  }
 }
}
